﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.8
@EndOfDesignText@
Sub Class_Globals
	Public LocManager As LocationManager
	Public strHeading As String,blnEnable As Boolean
	Public strAltitude As String,strBearing As String,strLL As String
	Public strSpeed  As String,strTime As String,strAccuracy As String
	Public Latitude As Double,Longitude As Double,strError As String,strLog As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

	LocManager.Initialize("LocManager")
	strError=""
	strHeading =""
	strAltitude=""
	strBearing=""
	strLL=""
	strSpeed=""
	strTime=""
	strAccuracy=""
	strLog="LocManager.Initialize" & CRLF
End Sub


public Sub LocManager_AuthorizationStatusChanged (Status As Int)
	
	Try
		
		If LocManager.AuthorizationStatus = LocManager.AUTHORIZATION_DENIED Then
			Log("AUTHORIZATION_DENIED")
			strLog="AUTHORIZATION_DENIED"
			blnEnable=False
		Else if LocManager.AuthorizationStatus = LocManager.AUTHORIZATION_RESTRICTED Then
			Log("AUTHORIZATION_RESTRICTED")
			strLog="AUTHORIZATION_RESTRICTED"
			blnEnable=False
			
		Else
			Log("AUTHORIZATION " & LocManager.AuthorizationStatus)
			strLog="AUTHORIZATION " & LocManager.AuthorizationStatus & CRLF
			blnEnable=True
		End If
		
		Main.IsGPSOk=blnEnable
		
		StartLocationUpdates
	
	Catch
		Log("LocManager_AuthorizationStatusChanged " & LastException.description)
		strError=strError & "LocManager_AuthorizationStatusChanged " & LastException.description & CRLF
	End Try
	
End Sub


public Sub StartLocationUpdates
	
	Try
		
		'if the user allowed us to use the location service or if we never asked the user before then we call LocationManager.Start.
		If LocManager.IsAuthorized Or LocManager.AuthorizationStatus = LocManager.AUTHORIZATION_NOT_DETERMINED Then
			LocManager.Start(0)
			strLog =strLog & "LocManager.Start(0)" & CRLF
		End If
		LocManager.StartHeading
		strLog =strLog & "LocManager.StartHeading" & CRLF
	
	Catch
		Log("StartLocationUpdates " & LastException.description)
		strError=strError &"StartLocationUpdates " & LastException.description & CRLF
	End Try
	
End Sub


Public Sub LocManager_HeadingChanged (MagneticHeading As Double, TrueHeading As Double)
	
	Try
		
		If TrueHeading >= 0 Then
			strHeading = NumberFormat(TrueHeading, 1, 0) & Chr(176) & " (true north)"
		Else
			strHeading = NumberFormat(MagneticHeading, 1, 0) & Chr(176) & " (magnetic)"
		End If
	
		
		Log("strHeading=" & strHeading)
		strLog=strLog & "LocManager_HeadingChanged " & TAB & strHeading & CRLF
	Catch
		Log("LocManager_HeadingChanged " & LastException.description)
		strError=strError & "LocManager_HeadingChanged " & LastException.description & CRLF
	End Try
End Sub

public Sub LocManager_AllowCalibration As Boolean
	Return True
End Sub

public Sub LocManager_LocationError
	Log("Error: " & LastException.description)
	strError=strError & "Error: " & LastException.description & CRLF
End Sub

public  Sub LocManager_LocationChanged (Location1 As Location)
	
	Try
		
		
		If Location1.VerticalAccuracy >= 0 Then
			strAltitude =	NumberFormat(Location1.Altitude, 1, 1) & "m"
		Else
			strAltitude = "N/A"
		End If
		strBearing = ValueOrNA (Location1.Bearing, 1, Chr(176))
		If Location1.Accuracy >= 0 Then
			strLL = NumberFormat(Location1.Latitude, 2, 4) & " / " & NumberFormat(Location1.Longitude, 2, 4)
			Latitude=NumberFormat(Location1.Latitude, 2, 4)
			Longitude=NumberFormat(Location1.Longitude, 2, 4)
		Else
			strLL = "N/A"
			Latitude=0
			Longitude=0
		End If
		strSpeed = ValueOrNA(Location1.Speed, 1, "m/s")
		strTime = DateTime.Time(Location1.Time)
		strAccuracy = ValueOrNA(Location1.Accuracy, 2, "m")
	
		strLog =strLog & "LocManager_LocationChanged " & CRLF
		strLog=strLog & "Location1.VerticalAccuracy" & TAB & Location1.VerticalAccuracy & CRLF
		strLog=strLog & "Location1.Accuracy" & TAB & Location1.Accuracy & CRLF
	
		Log("strAltitude=" & strAltitude)
		Log("strBearing=" & strBearing)
		Log("strLL=" & strLL)
		Log("strSpeed=" & strSpeed)
		Log("strTime=" & strTime)
		Log("strAccuracy=" & strAccuracy)
		

	Catch
		Log("LocManager_LocationChanged " & LastException.description)
		strError=strError & "LocManager_LocationChanged " & LastException.description & CRLF
	End Try

End Sub

Private Sub ValueOrNA(value As Double, NumberOfFractions As Int, unit As String) As String
	
	Try
		If value < 0 Then
			Return "N/A"
		Else
			Return NumberFormat(value, 1, NumberOfFractions) & unit
		End If
	
	Catch
		Log("ValueOrNA " & LastException.description)
		strError=strError & "ValueOrNA " & LastException.description & CRLF
		Return "Error"
	End Try
	
End Sub




public Sub CheckGPS As Boolean
	Try

		Return Main.IsGPSOk
		
	Catch
		Log("CheckGPS " & LastException.Description)
		strError=strError & "CheckGPS " & LastException.Description & CRLF
		Return False
	End Try
End Sub

